//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_Attenuator.h
//  Version: 1.0, Updated on 2005/09/08 at 20:14:34
//  Application: PSoC Express 2.0
//
//  DESCRIPTION:  Header file for the Attenuator Driver
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2001-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#ifndef `@LIB_NAME`_ATTENUATOR_DRV_HEADER
#define `@LIB_NAME`_ATTENUATOR_DRV_HEADER

`@ATTENUATOR_ORDINAL_DEFINE_BLOCK`

// Attenuator input Parameter block

typedef struct
{
	BYTE ID;	 // Instance ID.  This ID value will be set upon code generation
                 // and will refer to the index in the array of pointers to 
                 // parameter blocks.

	BYTE InPort; //  This is actually the index of the input channel to the ADC
                 //  scan array. The scan array in independent of the port or pin
                 //  that the input is on.
	
	int Upper_Voltage_Limit;
	
}`@LIB_NAME`_Attenuator_ParameterBlock;

// Function prototypes
void `@LIB_NAME`_Attenuator_Instantiate( const `@LIB_NAME`_Attenuator_ParameterBlock * thisBLK );
int  `@LIB_NAME`_Attenuator_GetValue( const `@LIB_NAME`_Attenuator_ParameterBlock * thisBLK );
#endif
