//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_LCDNVU.c
//   Version: 1.2, Updated on 2007/04/18 at 15:18:39
//  Application: PSoC Express 2.0
//
//  DESCRIPTION:  This file contains the C code for LCDNVU Driver.
//
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2004-2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include "m8c.h"
#include "`@LIB_NAME`_LCDNVU.h"
#include "cmx.h"
#include "SystemTimer.h"
// Channel type header file
#include "CMX_LCD_CHAN.h"


//-----------------------------------------------------------------------------
//  FUNCTION NAME: LCDNVU_Instantiate(const `@LIB_NAME`_LCDNVU_ParameterBlock * thisBLK)
//
//  DESCRIPTION: LCDNVU Initialization
//
//-----------------------------------------------------------------------------
//
//  ARGUMENTS: 
//    thisBLK  => Pointer to device parameter block
//
//  RETURNS: None
//
//  SIDE EFFECTS: 
//
//  THEORY of OPERATION or PROCEDURE: 
//  	Initialization for  LCDNVU 
//      Display driver name and integer value on positions 
//      accordingly to the user-configurable property
////////////////////////////////////////////////////////////////////////////////

void `@LIB_NAME`_LCDNVU_Instantiate(const `@LIB_NAME`_LCDNVU_ParameterBlock * thisBLK)
{
	BYTE i;
	BYTE arbLabelUnit[17];
	LCD_Position(thisBLK->bNumberRows,0); //set position (selected  row, column 0)
	for(i=0;i<16;i++)
	{
		arbLabelUnit[i] = thisBLK->pDriver_Name[i];
		if (arbLabelUnit[i] == 0x00)
			break;
		if (arbLabelUnit[i] == '_')
			arbLabelUnit[i] = ' ';
	}
	arbLabelUnit[16] = 0x00;
	//display Driver_Name that choosen by user as property
	LCD_PrString(arbLabelUnit); 
	
	LCD_Position(thisBLK->bNumberRows+1,8);//set position (selected  row, column 8)
	for(i=0;i<8;i++)
	{
		arbLabelUnit[i] = thisBLK->pUnits[i];
		if (arbLabelUnit[i] == 0x00)
			break;
		if (arbLabelUnit[i] == '_')
			arbLabelUnit[i] = ' ';
	}
	arbLabelUnit[8] = 0x00;
	//display Units that choosen by user as property
	LCD_PrString(arbLabelUnit);
	
}
//-----------------------------------------------------------------------------
//  FUNCTION NAME: LCDNVU_SetValue(const `@LIB_NAME`_LCDNVU_ParameterBlock * thisBLK, int iValue)
//
//  DESCRIPTION: LCDNVU Display  iValue, Driver Name and Units
//
//-----------------------------------------------------------------------------
//
//  ARGUMENTS: 
//    thisBLK       => Pointer to parameter block
//    iValue          => integer displaying value
//
//  RETURNS: None
//
//  SIDE EFFECTS: 
//
//  THEORY of OPERATION or PROCEDURE:  
//  This driver displays on LCD current integer value in hexdecimal or decimal code.

////////////////////////////////////////////////////////////////////////////////
void `@LIB_NAME`_LCDNVU_SetValue(const `@LIB_NAME`_LCDNVU_ParameterBlock * thisBLK, int iValue)
{
	
	LCD_Position(thisBLK->bNumberRows+1,0);//set position (selected row, column 0)
	//select the scale of notation
	if (thisBLK->bScaleNotation)
	    LCDPrDecInt(iValue); //display integer value in decimal
	else
		LCD_PrHexInt(iValue); //display integer value in hexdecimal
	
}
