	.module cmx_adc_chan_c.c
	.area text(rom, con, rel)
	.dbfile ./cmx_adc_chan_c.c
	.dbfunc e iGetChanMVolts _iGetChanMVolts fI
;          lTemp -> X+0
;          bChan -> X-4
_iGetChanMVolts::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 39
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  ADCMux8_LLD.h              
; //  @Version@
; //  
; //
; //  DESCRIPTION:  This files contains the conversion from ADC counts to
; //                mVolts.  The driver will ALWAYS cal the " iGetChanMVolts()"
; //                function to retrieve the mVolts result.
; //
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "m8c.h"
; #include "calibration.h"
; #include "CMX_ADC_CHAN.h"
; 
; extern void * const DriverParams[]; 
; 
; // ADC Parameters
; //
; #define ADC_RESOLUTION  12
; 
; 
; 
; // *********************** iGetChanMVolts() *******************************
; //
; // Description:
; //   This function returns the reading of a given channel in mVolts (int).
; //
; //  Input:
; //    BYTE bChan  <= Voltage channel number
; //
; //
; //
; int iGetChanMVolts(BYTE bChan)
; {
	.dbline 42
;    long lTemp;                                                    // Temp long variable 
; 
;    lTemp = (long)(iGetAinChanCounts(bChan) + ADC_Offset) * 1000;
	push X
	mov A,[X-4]
	xcall _iGetAinChanCounts
	mov [__r1],A
	mov [__r0],X
	pop X
	mov A,>_ADC_Offset
	push X
	push A
	mov X,<_ADC_Offset
	romx
	mov [__r2],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	add [__r1],A
	mov A,[__r2]
	adc [__r0],A
	mov [__r3],[__r1]
	mov [__r2],[__r0]
	tst [__r2],-128
	jz X0
	mov [__r1],-1
	mov [__r0],-1
	jmp X1
X0:
	mov [__r1],0
	mov [__r0],0
X1:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,0
	push A
	push A
	mov A,3
	push A
	mov A,-24
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 45
;    // The COUNTS_PER_VOLT is a default value at this time.  Later it
;    // will be set by a calibration sequence.
;    lTemp = lTemp/(CMX_ADC_CHAN_COUNTS16_PER_VOLT >> (16-CMX_ADC_CHAN_RESOLUTION));
	mov A,0
	push A
	push A
	mov A,6
	push A
	mov A,39
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 47
; 
;    return ((int)lTemp);
	mov A,[X+3]
	mov [__r1],A
	mov A,[X+2]
	mov [__r0],A
	.dbline -2
L1:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l lTemp 0 L
	.dbsym l bChan -4 c
	.dbend
