	.module cmx_attenuator.c
	.area text(rom, con, rel)
	.dbfile ./cmx_attenuator.c
	.dbfunc e CMX_Attenuator_Instantiate _CMX_Attenuator_Instantiate fV
;        thisBLK -> X-5
_CMX_Attenuator_Instantiate::
	.dbline -1
	push X
	mov X,SP
	.dbline 45
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_Attenuator.c
; //  Version: 1.0, Updated on 2005/09/08 at 20:14:34
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This Driver calls the low level driver and returns the
; //                voltage that corresponds to a given channel.
; //
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "m8c.h"
; #include "CMX_Attenuator.h"
; #include "cmx.h"
; #include "calibration.h"
; 
; // Channel type header file
; #include "CMX_MVOLTS_IN_CHAN.h"
; 
; 
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: Attenuator_Instantiate(const CMX_Attenuator_ParameterBlock * thisBLK)
; //
; //  DESCRIPTION:  
; //    This function doesn't do anything at this time, but is placed here
; //    for forward compatibility.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    thisBLK  => Pointer to ParameterBlock for this instance.
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; //-----------------------------------------------------------------------------
; void CMX_Attenuator_Instantiate(const CMX_Attenuator_ParameterBlock * thisBLK)
; {
	.dbline -2
	.dbline 48
;    // Blank function
;    
; }
L2:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l thisBLK -5 pX
	.dbend
	.dbfunc e CMX_Attenuator_GetValue _CMX_Attenuator_GetValue fI
;          bChan -> X+4
;        lmVolts -> X+0
;        thisBLK -> X-5
_CMX_Attenuator_GetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,5
	.dbline 73
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: Attenuator_GetValue(const CMX_Attenuator_ParameterBlock * thisBLK)
; //
; //  DESCRIPTION:  
; //	This function returns a current value of input voltage.
; //         
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    thisBLK  => Pointer to ParameterBlock for this instance.
; //
; //  RETURNS:   A unsigned integer value (two bytes) of input voltage(in milivolts).
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; //  The voltage output is scaled by using the ScaleNumerator and ScaleDenominator
; //  in the parameter block.
; //
; //-----------------------------------------------------------------------------
; 
; int  CMX_Attenuator_GetValue(const CMX_Attenuator_ParameterBlock * thisBLK)
; {
	.dbline 77
; 	BYTE bChan;
; 	long  lmVolts;
; 
; 	bChan = thisBLK->InPort;                  // Get channel from PB
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+4],A
	.dbline 78
; 	lmVolts = (long)iGetChanMVolts(bChan);
	mov A,[X+4]
	push A
	xcall _iGetChanMVolts
	add SP,-1
	mov A,[__r1]
	mov [X+3],A
	mov A,[__r0]
	mov [X+2],A
	tst [X+2],-128
	jz X0
	mov [X+1],-1
	mov [X+0],-1
	jmp X1
X0:
	mov [X+1],0
	mov [X+0],0
X1:
	.dbline 81
; 	
; 	
; 	lmVolts = lmVolts * thisBLK->Upper_Voltage_Limit;
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [__r3],A
	mov [__r2],[__r0]
	tst [__r2],-128
	jz X2
	mov [__r1],-1
	mov [__r0],-1
	jmp X3
X2:
	mov [__r1],0
	mov [__r0],0
X3:
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 82
; 	lmVolts = lmVolts>>10;
	mov A,[X+0]
	mov [__r0],A
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+2]
	mov [__r2],A
	mov A,[X+3]
	mov [__r3],A
	mov A,10
X4:
	asr [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X4
	mov A,[__r0]
	mov [X+0],A
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r2]
	mov [X+2],A
	mov A,[__r3]
	mov [X+3],A
	.dbline 84
; 	
; 	lmVolts += imVolts_Chan_Offset[bChan];   // Add user calibration offset
	mov A,[X+4]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_imVolts_Chan_Offset
	adc [__r0],>_imVolts_Chan_Offset
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	mov [__r3],A
	mov [__r2],[__r0]
	tst [__r2],-128
	jz X5
	mov [__r1],-1
	mov [__r0],-1
	jmp X6
X5:
	mov [__r1],0
	mov [__r0],0
X6:
	mov A,[__r3]
	add [X+3],A
	mov A,[__r2]
	adc [X+2],A
	mov A,[__r1]
	adc [X+1],A
	mov A,[__r0]
	adc [X+0],A
	.dbline 85
; 	return((int)lmVolts);                    // Convert to mVolts and return
	mov A,[X+3]
	mov [__r1],A
	mov A,[X+2]
	mov [__r0],A
	.dbline -2
L3:
	add SP,-5
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l bChan 4 c
	.dbsym l lmVolts 0 L
	.dbsym l thisBLK -5 pX
	.dbend
