	.module cmx_lcdnvu.c
	.area text(rom, con, rel)
	.dbfile ./cmx_lcdnvu.c
	.dbfunc e CMX_LCDNVU_Instantiate _CMX_LCDNVU_Instantiate fV
;   arbLabelUnit -> X+1
;              i -> X+0
;        thisBLK -> X-5
_CMX_LCDNVU_Instantiate::
	.dbline -1
	push X
	mov X,SP
	add SP,18
	.dbline 43
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_LCDNVU.c
; //   Version: 1.2, Updated on 2007/04/18 at 15:18:39
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This file contains the C code for LCDNVU Driver.
; //
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2004-2006. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "m8c.h"
; #include "CMX_LCDNVU.h"
; #include "cmx.h"
; #include "SystemTimer.h"
; // Channel type header file
; #include "CMX_LCD_CHAN.h"
; 
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: LCDNVU_Instantiate(const CMX_LCDNVU_ParameterBlock * thisBLK)
; //
; //  DESCRIPTION: LCDNVU Initialization
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    thisBLK  => Pointer to device parameter block
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //  	Initialization for  LCDNVU 
; //      Display driver name and integer value on positions 
; //      accordingly to the user-configurable property
; ////////////////////////////////////////////////////////////////////////////////
; 
; void CMX_LCDNVU_Instantiate(const CMX_LCDNVU_ParameterBlock * thisBLK)
; {
	.dbline 46
; 	BYTE i;
; 	BYTE arbLabelUnit[17];
; 	LCD_Position(thisBLK->bNumberRows,0); //set position (selected  row, column 0)
	push X
	mov A,0
	push A
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	push X
	mov X,[__r1]
	romx
	pop X
	pop X
	xcall _LCD_Position
	pop X
	.dbline 47
; 	for(i=0;i<16;i++)
	mov [X+0],0
	xjmp L6
L3:
	.dbline 48
; 	{
	.dbline 49
; 		arbLabelUnit[i] = thisBLK->pDriver_Name[i];
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mov A,0
	adc A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	mov [__r3],X
	add [__r3],1
	mov A,[X+0]
	add A,[__r3]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 50
; 		if (arbLabelUnit[i] == 0x00)
	mov [__r1],X
	add [__r1],1
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mvi A,[__r1]
	jnz L7
	.dbline 51
; 			break;
	xjmp L5
L7:
	.dbline 52
; 		if (arbLabelUnit[i] == '_')
	mov [__r1],X
	add [__r1],1
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mvi A,[__r1]
	cmp A,95
	jnz L9
	.dbline 53
; 			arbLabelUnit[i] = ' ';
	mov [__r1],X
	add [__r1],1
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mov A,32
	mvi [__r1],A
L9:
	.dbline 54
L4:
	.dbline 47
	inc [X+0]
L6:
	.dbline 47
	cmp [X+0],16
	jc L3
X0:
L5:
	.dbline 55
; 	}
; 	arbLabelUnit[16] = 0x00;
	mov [X+17],0
	.dbline 57
; 	//display Driver_Name that choosen by user as property
; 	LCD_PrString(arbLabelUnit); 
	mov [__r1],X
	add [__r1],1
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _LCD_PrString
	pop X
	.dbline 59
; 	
; 	LCD_Position(thisBLK->bNumberRows+1,8);//set position (selected  row, column 8)
	push X
	mov A,8
	push A
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	push X
	mov X,[__r1]
	romx
	pop X
	add A,1
	pop X
	xcall _LCD_Position
	pop X
	.dbline 60
; 	for(i=0;i<8;i++)
	mov [X+0],0
	xjmp L15
L12:
	.dbline 61
; 	{
	.dbline 62
; 		arbLabelUnit[i] = thisBLK->pUnits[i];
	mov A,[X-4]
	add A,3
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mov A,0
	adc A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	mov [__r3],X
	add [__r3],1
	mov A,[X+0]
	add A,[__r3]
	mov [__r3],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 63
; 		if (arbLabelUnit[i] == 0x00)
	mov [__r1],X
	add [__r1],1
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mvi A,[__r1]
	jnz L16
	.dbline 64
; 			break;
	xjmp L14
L16:
	.dbline 65
; 		if (arbLabelUnit[i] == '_')
	mov [__r1],X
	add [__r1],1
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mvi A,[__r1]
	cmp A,95
	jnz L18
	.dbline 66
; 			arbLabelUnit[i] = ' ';
	mov [__r1],X
	add [__r1],1
	mov A,[X+0]
	add A,[__r1]
	mov [__r1],A
	mov A,32
	mvi [__r1],A
L18:
	.dbline 67
L13:
	.dbline 60
	inc [X+0]
L15:
	.dbline 60
	cmp [X+0],8
	jc L12
X1:
L14:
	.dbline 68
; 	}
; 	arbLabelUnit[8] = 0x00;
	mov [X+9],0
	.dbline 70
; 	//display Units that choosen by user as property
; 	LCD_PrString(arbLabelUnit);
	mov [__r1],X
	add [__r1],1
	push X
	mov A,[__r0]
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _LCD_PrString
	pop X
	.dbline -2
	.dbline 72
; 	
; }
L2:
	add SP,-18
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l arbLabelUnit 1 A[17:17]c
	.dbsym l i 0 c
	.dbsym l thisBLK -5 pX
	.dbend
	.dbfunc e CMX_LCDNVU_SetValue _CMX_LCDNVU_SetValue fV
;         iValue -> X-7
;        thisBLK -> X-5
_CMX_LCDNVU_SetValue::
	.dbline -1
	push X
	mov X,SP
	.dbline 93
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: LCDNVU_SetValue(const CMX_LCDNVU_ParameterBlock * thisBLK, int iValue)
; //
; //  DESCRIPTION: LCDNVU Display  iValue, Driver Name and Units
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    thisBLK       => Pointer to parameter block
; //    iValue          => integer displaying value
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE:  
; //  This driver displays on LCD current integer value in hexdecimal or decimal code.
; 
; ////////////////////////////////////////////////////////////////////////////////
; void CMX_LCDNVU_SetValue(const CMX_LCDNVU_ParameterBlock * thisBLK, int iValue)
; {
	.dbline 95
; 	
; 	LCD_Position(thisBLK->bNumberRows+1,0);//set position (selected row, column 0)
	push X
	mov A,0
	push A
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	push X
	mov X,[__r1]
	romx
	pop X
	add A,1
	pop X
	xcall _LCD_Position
	pop X
	.dbline 97
; 	//select the scale of notation
; 	if (thisBLK->bScaleNotation)
	mov A,[X-4]
	add A,5
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	cmp A,0
	jz L22
	.dbline 98
; 	    LCDPrDecInt(iValue); //display integer value in decimal
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	xcall _LCDPrDecInt
	add SP,-2
	xjmp L23
L22:
	.dbline 100
	push X
	mov A,[X-7]
	push A
	mov A,[X-6]
	pop X
	xcall _LCD_PrHexInt
	pop X
L23:
	.dbline -2
	.dbline 102
; 	else
; 		LCD_PrHexInt(iValue); //display integer value in hexdecimal
; 	
; }
L21:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l iValue -7 I
	.dbsym l thisBLK -5 pX
	.dbend
