	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
_main::
	.dbline -1
	.dbline 24
; //----------------------------------------------------------------------------
; // C main line
; //----------------------------------------------------------------------------
; 
; #include <m8c.h>          // part specific constants and macros
; #include "PSoCAPI.h"      // PSoC API definitions for all User Modules
; 
; #include "driverdecl.h"
; #include "CMXSystem.h"
; #include "CMXSystemExtern.h"
; #include "TransferFunction.h"
; 
; #include "cmx.h"
; #include "ProjectProperties.h"
; #include "Custom.h"
; 
; // Channel includes
; // ADC_00 Include
; #include "CMX_ADC_CHAN.h"
; // LCD_SHARED_01 Include
; #include "cmx_lcd_chan.h"
; 
; void main()
; {
	.dbline 26
;     // Initialize Project
;     M8C_EnableGInt;                            // Turn on interrupts 
		or  F, 01h

	.dbline 27
;     I2C_CFG &= 0xFC;                           // Disable I2C in case it's not used.
	and REG[0xd6],-4
	.dbline 28
;     SystemTimer_Start();
	push X
	xcall _SystemTimer_Start
	.dbline 29
;     SystemTimer_SetInterval(SystemTimer_64_HZ);
	mov A,8
	xcall _SystemTimer_SetInterval
	.dbline 30
;     SystemTimer_EnableInt();
	xcall _SystemTimer_EnableInt
	.dbline 34
; 
;     // Initialize Channels
;     // ADC_00 Initialization  
;     ADCBUF_Start(3); // Power up ADC Buffer PGA
	mov A,3
	xcall _ADCBUF_Start
	.dbline 35
;     ADC_Start(3); // Power up ADC
	mov A,3
	xcall _ADC_Start
	.dbline 36
;     AdcScanReset(); // Initialize ADC scanner
	xcall _AdcScanReset
	.dbline 37
;     ADC_GetSamples(0); // Turn on GetSamples
	mov A,0
	xcall _ADC_GetSamples
	pop X
	.dbline 39
;     // LCD_SHARED_01 Initialization
;     LCDStartSharedChan();
	xcall _LCDStartSharedChan
	.dbline 42
; 
;     // Initialize Variables
; 	SystemVars.ReadOnlyVars.pse_ADC = 0;
	mov [_SystemVars+2+1],0
	mov [_SystemVars+2],0
	.dbline 43
; 	SystemVars.ReadOnlyVars.pse_D1 = 0;
	mov [_SystemVars+4],0
	.dbline 44
; 	SystemVars.ReadOnlyVars.pse_D10 = 0;
	mov [_SystemVars+5],0
	.dbline 45
; 	SystemVars.ReadOnlyVars.pse_D11 = 0;
	mov [_SystemVars+6],0
	.dbline 46
; 	SystemVars.ReadOnlyVars.pse_D12 = 0;
	mov [_SystemVars+7],0
	.dbline 47
; 	SystemVars.ReadOnlyVars.pse_D13 = 0;
	mov [_SystemVars+8],0
	.dbline 48
; 	SystemVars.ReadOnlyVars.pse_D14 = 0;
	mov [_SystemVars+9],0
	.dbline 49
; 	SystemVars.ReadOnlyVars.pse_D2 = 0;
	mov [_SystemVars+10],0
	.dbline 50
; 	SystemVars.ReadOnlyVars.pse_D3 = 0;
	mov [_SystemVars+11],0
	.dbline 51
; 	SystemVars.ReadOnlyVars.pse_D4 = 0;
	mov [_SystemVars+12],0
	.dbline 52
; 	SystemVars.ReadOnlyVars.pse_D5 = 0;
	mov [_SystemVars+13],0
	.dbline 53
; 	SystemVars.ReadOnlyVars.pse_D6 = 0;
	mov [_SystemVars+14],0
	.dbline 54
; 	SystemVars.ReadOnlyVars.pse_D7 = 0;
	mov [_SystemVars+15],0
	.dbline 55
; 	SystemVars.ReadOnlyVars.pse_D8 = 0;
	mov [_SystemVars+16],0
	.dbline 56
; 	SystemVars.ReadOnlyVars.pse_D9 = 0;
	mov [_SystemVars+17],0
	.dbline 57
; 	SystemVars.ReadOnlyVars.pse_LCD_VAL = 0;
	mov [_SystemVars+1],0
	mov [_SystemVars],0
	.dbline 60
; 
;     // Driver instantiations
; CMX_DIO_Instantiate(&pse_D9);
	mov A,>_pse_D9
	push A
	mov A,<_pse_D9
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 61
; CMX_DIO_SetValue(&pse_D9, (BYTE)SystemVars.ReadOnlyVars.pse_D9);
	mov A,[_SystemVars+17]
	push A
	mov A,>_pse_D9
	push A
	mov A,<_pse_D9
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 62
; CMX_DIO_Instantiate(&pse_D10);
	mov A,>_pse_D10
	push A
	mov A,<_pse_D10
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 63
; CMX_DIO_SetValue(&pse_D10, (BYTE)SystemVars.ReadOnlyVars.pse_D10);
	mov A,[_SystemVars+5]
	push A
	mov A,>_pse_D10
	push A
	mov A,<_pse_D10
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 64
; CMX_DIO_Instantiate(&pse_D11);
	mov A,>_pse_D11
	push A
	mov A,<_pse_D11
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 65
; CMX_DIO_SetValue(&pse_D11, (BYTE)SystemVars.ReadOnlyVars.pse_D11);
	mov A,[_SystemVars+6]
	push A
	mov A,>_pse_D11
	push A
	mov A,<_pse_D11
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 66
; CMX_DIO_Instantiate(&pse_D12);
	mov A,>_pse_D12
	push A
	mov A,<_pse_D12
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 67
; CMX_DIO_SetValue(&pse_D12, (BYTE)SystemVars.ReadOnlyVars.pse_D12);
	mov A,[_SystemVars+7]
	push A
	mov A,>_pse_D12
	push A
	mov A,<_pse_D12
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 68
; CMX_DIO_Instantiate(&pse_D13);
	mov A,>_pse_D13
	push A
	mov A,<_pse_D13
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 69
; CMX_DIO_SetValue(&pse_D13, (BYTE)SystemVars.ReadOnlyVars.pse_D13);
	mov A,[_SystemVars+8]
	push A
	mov A,>_pse_D13
	push A
	mov A,<_pse_D13
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 70
; CMX_DIO_Instantiate(&pse_D14);
	mov A,>_pse_D14
	push A
	mov A,<_pse_D14
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 71
; CMX_DIO_SetValue(&pse_D14, (BYTE)SystemVars.ReadOnlyVars.pse_D14);
	mov A,[_SystemVars+9]
	push A
	mov A,>_pse_D14
	push A
	mov A,<_pse_D14
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 72
; CMX_DIO_Instantiate(&pse_D1);
	mov A,>_pse_D1
	push A
	mov A,<_pse_D1
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 73
; CMX_DIO_SetValue(&pse_D1, (BYTE)SystemVars.ReadOnlyVars.pse_D1);
	mov A,[_SystemVars+4]
	push A
	mov A,>_pse_D1
	push A
	mov A,<_pse_D1
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 74
; CMX_DIO_Instantiate(&pse_D2);
	mov A,>_pse_D2
	push A
	mov A,<_pse_D2
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 75
; CMX_DIO_SetValue(&pse_D2, (BYTE)SystemVars.ReadOnlyVars.pse_D2);
	mov A,[_SystemVars+10]
	push A
	mov A,>_pse_D2
	push A
	mov A,<_pse_D2
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 76
; CMX_DIO_Instantiate(&pse_D3);
	mov A,>_pse_D3
	push A
	mov A,<_pse_D3
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 77
; CMX_DIO_SetValue(&pse_D3, (BYTE)SystemVars.ReadOnlyVars.pse_D3);
	mov A,[_SystemVars+11]
	push A
	mov A,>_pse_D3
	push A
	mov A,<_pse_D3
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 78
; CMX_DIO_Instantiate(&pse_D4);
	mov A,>_pse_D4
	push A
	mov A,<_pse_D4
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 79
; CMX_DIO_SetValue(&pse_D4, (BYTE)SystemVars.ReadOnlyVars.pse_D4);
	mov A,[_SystemVars+12]
	push A
	mov A,>_pse_D4
	push A
	mov A,<_pse_D4
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 80
; CMX_DIO_Instantiate(&pse_D5);
	mov A,>_pse_D5
	push A
	mov A,<_pse_D5
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 81
; CMX_DIO_SetValue(&pse_D5, (BYTE)SystemVars.ReadOnlyVars.pse_D5);
	mov A,[_SystemVars+13]
	push A
	mov A,>_pse_D5
	push A
	mov A,<_pse_D5
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 82
; CMX_DIO_Instantiate(&pse_D6);
	mov A,>_pse_D6
	push A
	mov A,<_pse_D6
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 83
; CMX_DIO_SetValue(&pse_D6, (BYTE)SystemVars.ReadOnlyVars.pse_D6);
	mov A,[_SystemVars+14]
	push A
	mov A,>_pse_D6
	push A
	mov A,<_pse_D6
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 84
; CMX_DIO_Instantiate(&pse_D7);
	mov A,>_pse_D7
	push A
	mov A,<_pse_D7
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 85
; CMX_DIO_SetValue(&pse_D7, (BYTE)SystemVars.ReadOnlyVars.pse_D7);
	mov A,[_SystemVars+15]
	push A
	mov A,>_pse_D7
	push A
	mov A,<_pse_D7
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 86
; CMX_DIO_Instantiate(&pse_D8);
	mov A,>_pse_D8
	push A
	mov A,<_pse_D8
	push A
	xcall _CMX_DIO_Instantiate
	.dbline 87
; CMX_DIO_SetValue(&pse_D8, (BYTE)SystemVars.ReadOnlyVars.pse_D8);
	mov A,[_SystemVars+16]
	push A
	mov A,>_pse_D8
	push A
	mov A,<_pse_D8
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 88
; CMX_LCDNVU_Instantiate(&pse_LCD_VAL);
	mov A,>_pse_LCD_VAL
	push A
	mov A,<_pse_LCD_VAL
	push A
	xcall _CMX_LCDNVU_Instantiate
	.dbline 89
; CMX_Attenuator_Instantiate(&pse_ADC);
	mov A,>_pse_ADC
	push A
	mov A,<_pse_ADC
	push A
	xcall _CMX_Attenuator_Instantiate
	add SP,-4
	.dbline 92
; 
;     // Custom initization code.
;     CustomInit();
	xcall _CustomInit
	xjmp L39
L38:
	.dbline 96
	.dbline 99
	push X
	mov X,0
	mov A,1
	xcall _SystemTimer_SyncWait
	pop X
	.dbline 103
	mov A,>_pse_ADC
	push A
	mov A,<_pse_ADC
	push A
	xcall _CMX_Attenuator_GetValue
	mov [_SystemVars+2+1],[__r1]
	mov [_SystemVars+2],[__r0]
	.dbline 106
	xcall _CustomPostInputUpdate
	.dbline 109
	xcall _TransferFunction
	.dbline 112
	xcall _CustomPreOutputUpdate
	.dbline 115
	mov A,[_SystemVars+4]
	push A
	mov A,>_pse_D1
	push A
	mov A,<_pse_D1
	push A
	xcall _CMX_DIO_SetValue
	add SP,-5
	.dbline 116
	mov A,[_SystemVars+5]
	push A
	mov A,>_pse_D10
	push A
	mov A,<_pse_D10
	push A
	xcall _CMX_DIO_SetValue
	.dbline 117
	mov A,[_SystemVars+6]
	push A
	mov A,>_pse_D11
	push A
	mov A,<_pse_D11
	push A
	xcall _CMX_DIO_SetValue
	add SP,-6
	.dbline 118
	mov A,[_SystemVars+7]
	push A
	mov A,>_pse_D12
	push A
	mov A,<_pse_D12
	push A
	xcall _CMX_DIO_SetValue
	.dbline 119
	mov A,[_SystemVars+8]
	push A
	mov A,>_pse_D13
	push A
	mov A,<_pse_D13
	push A
	xcall _CMX_DIO_SetValue
	add SP,-6
	.dbline 120
	mov A,[_SystemVars+9]
	push A
	mov A,>_pse_D14
	push A
	mov A,<_pse_D14
	push A
	xcall _CMX_DIO_SetValue
	.dbline 121
	mov A,[_SystemVars+10]
	push A
	mov A,>_pse_D2
	push A
	mov A,<_pse_D2
	push A
	xcall _CMX_DIO_SetValue
	add SP,-6
	.dbline 122
	mov A,[_SystemVars+11]
	push A
	mov A,>_pse_D3
	push A
	mov A,<_pse_D3
	push A
	xcall _CMX_DIO_SetValue
	.dbline 123
	mov A,[_SystemVars+12]
	push A
	mov A,>_pse_D4
	push A
	mov A,<_pse_D4
	push A
	xcall _CMX_DIO_SetValue
	add SP,-6
	.dbline 124
	mov A,[_SystemVars+13]
	push A
	mov A,>_pse_D5
	push A
	mov A,<_pse_D5
	push A
	xcall _CMX_DIO_SetValue
	.dbline 125
	mov A,[_SystemVars+14]
	push A
	mov A,>_pse_D6
	push A
	mov A,<_pse_D6
	push A
	xcall _CMX_DIO_SetValue
	add SP,-6
	.dbline 126
	mov A,[_SystemVars+15]
	push A
	mov A,>_pse_D7
	push A
	mov A,<_pse_D7
	push A
	xcall _CMX_DIO_SetValue
	.dbline 127
	mov A,[_SystemVars+16]
	push A
	mov A,>_pse_D8
	push A
	mov A,<_pse_D8
	push A
	xcall _CMX_DIO_SetValue
	add SP,-6
	.dbline 128
	mov A,[_SystemVars+17]
	push A
	mov A,>_pse_D9
	push A
	mov A,<_pse_D9
	push A
	xcall _CMX_DIO_SetValue
	.dbline 129
	mov A,[_SystemVars]
	push A
	mov A,[_SystemVars+1]
	push A
	mov A,>_pse_LCD_VAL
	push A
	mov A,<_pse_LCD_VAL
	push A
	xcall _CMX_LCDNVU_SetValue
	add SP,-7
	.dbline 131
L39:
	.dbline 95
	xjmp L38
X0:
	.dbline -2
	.dbline 132
;     // End Initialize Project
; 
; 	while(1)
; 	{
;         // Sync loop sample rate
; #if ( SAMPLE_DIVIDER  )
;         SystemTimer_SyncWait(SAMPLE_DIVIDER, SystemTimer_WAIT_RELOAD);
; #endif
; 
; 		// update input variables
; 		SystemVars.ReadOnlyVars.pse_ADC = CMX_Attenuator_GetValue(&pse_ADC);
; 
;         // Custom Post Input function
;         CustomPostInputUpdate();
; 
; 		// run transfer function and update output variables
; 		TransferFunction();
; 
;         // CustomPreOutputUpdate();
;         CustomPreOutputUpdate();
; 
; 		// set outputs
; 		CMX_DIO_SetValue(&pse_D1, (BYTE)SystemVars.ReadOnlyVars.pse_D1);
; 		CMX_DIO_SetValue(&pse_D10, (BYTE)SystemVars.ReadOnlyVars.pse_D10);
; 		CMX_DIO_SetValue(&pse_D11, (BYTE)SystemVars.ReadOnlyVars.pse_D11);
; 		CMX_DIO_SetValue(&pse_D12, (BYTE)SystemVars.ReadOnlyVars.pse_D12);
; 		CMX_DIO_SetValue(&pse_D13, (BYTE)SystemVars.ReadOnlyVars.pse_D13);
; 		CMX_DIO_SetValue(&pse_D14, (BYTE)SystemVars.ReadOnlyVars.pse_D14);
; 		CMX_DIO_SetValue(&pse_D2, (BYTE)SystemVars.ReadOnlyVars.pse_D2);
; 		CMX_DIO_SetValue(&pse_D3, (BYTE)SystemVars.ReadOnlyVars.pse_D3);
; 		CMX_DIO_SetValue(&pse_D4, (BYTE)SystemVars.ReadOnlyVars.pse_D4);
; 		CMX_DIO_SetValue(&pse_D5, (BYTE)SystemVars.ReadOnlyVars.pse_D5);
; 		CMX_DIO_SetValue(&pse_D6, (BYTE)SystemVars.ReadOnlyVars.pse_D6);
; 		CMX_DIO_SetValue(&pse_D7, (BYTE)SystemVars.ReadOnlyVars.pse_D7);
; 		CMX_DIO_SetValue(&pse_D8, (BYTE)SystemVars.ReadOnlyVars.pse_D8);
; 		CMX_DIO_SetValue(&pse_D9, (BYTE)SystemVars.ReadOnlyVars.pse_D9);
; 		CMX_LCDNVU_SetValue(&pse_LCD_VAL, (int)SystemVars.ReadOnlyVars.pse_LCD_VAL);
; 
; 	}
; }
L8:
	.dbline 0 ; func end
	jmp .
	.dbend
